Drawing Workbench: Difference between revisions

From FreeCAD Documentation
(add <translate>)
(Marked this version for translation)
Line 1: Line 1:
<translate>
<translate>
<!--T:1-->
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!


== GUI Tools ==
== GUI Tools == <!--T:2-->


<!--T:3-->
{{Drawing Tools}}
{{Drawing Tools}}




<!--T:4-->
'''Note'''
'''Note'''
The [[Draft Module]] has its own [[Draft_Drawing]] too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].
The [[Draft Module]] has its own [[Draft_Drawing]] too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].




<!--T:5-->
[[Image:Drawing_extraction.png|800px]]
[[Image:Drawing_extraction.png|800px]]


<!--T:6-->
In the picture you see the main concepts of the Drawing module. The document contains a shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The template is an SVG document which can hold your usual page frame, your logo or comply to your presentation standards.
In the picture you see the main concepts of the Drawing module. The document contains a shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The template is an SVG document which can hold your usual page frame, your logo or comply to your presentation standards.


<!--T:7-->
In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes the page gets regenerated and the page display updated.
In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes the page gets regenerated and the page display updated.


== Scripting ==
== Scripting == <!--T:8-->


<!--T:9-->
At the moment the end user(GUI) workflow is very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.
At the moment the end user(GUI) workflow is very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.


<!--T:10-->
Here a script that can easily fill the [[Macro_CartoucheFC]] leaf FreeCAD A3_Landscape.
Here a script that can easily fill the [[Macro_CartoucheFC]] leaf FreeCAD A3_Landscape.


=== Simple example ===
=== Simple example === <!--T:11-->


<!--T:12-->
First of all you need the Part and the Drawing module:
First of all you need the Part and the Drawing module:
</translate>
</translate>
Line 31: Line 40:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:13-->
Create a small sample part
Create a small sample part
</translate>
</translate>
Line 37: Line 47:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:14-->
Direct projection. The G0 means hard edge, the G1 is tangent continuous.
Direct projection. The G0 means hard edge, the G1 is tangent continuous.
</translate>
</translate>
Line 46: Line 57:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:15-->
Everything was projected on the Z-plane:
Everything was projected on the Z-plane:
</translate>
</translate>
Line 53: Line 65:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:16-->
Different projection vector
Different projection vector
</translate>
</translate>
Line 59: Line 72:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:17-->
Project to SVG
Project to SVG
</translate>
</translate>
Line 66: Line 80:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
=== The parametric way ===
=== The parametric way === <!--T:18-->


<!--T:19-->
Create the body
Create the body
</translate>
</translate>
Line 116: Line 131:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:20-->
Insert a Page object and assign a template
Insert a Page object and assign a template
</translate>
</translate>
Line 123: Line 139:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:21-->
Create a view on the "Shape" object, define the position and scale and assign it to a Page
Create a view on the "Shape" object, define the position and scale and assign it to a Page
</translate>
</translate>
Line 134: Line 151:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:22-->
Create a second view on the same object but this time the view will be rotated by 90 degrees.
Create a second view on the same object but this time the view will be rotated by 90 degrees.
</translate>
</translate>
Line 147: Line 165:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:23-->
Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.
Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.
</translate>
</translate>
Line 159: Line 178:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:24-->
Change something and update. The update process changes the view and the page.
Change something and update. The update process changes the view and the page.
</translate>
</translate>
Line 168: Line 188:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
=== Accessing the bits and pieces ===
=== Accessing the bits and pieces === <!--T:25-->


<!--T:26-->
Get the SVG fragment of a single view
Get the SVG fragment of a single view
</translate>
</translate>
Line 177: Line 198:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:27-->
Get the whole result page (it's a file in the document's temporary directory, only read permission)
Get the whole result page (it's a file in the document's temporary directory, only read permission)
</translate>
</translate>
Line 185: Line 207:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:28-->
Important: free the file!
Important: free the file!
</translate>
</translate>
Line 191: Line 214:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:29-->
Insert a view with your own content:
Insert a view with your own content:
</translate>
</translate>
Line 212: Line 236:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:30-->
That leads to the following result:
That leads to the following result:


<!--T:31-->
[[Image:DrawingScriptResult.jpg|800px]]
[[Image:DrawingScriptResult.jpg|800px]]


=== General Dimensioning and Tolerancing ===
=== General Dimensioning and Tolerancing === <!--T:32-->


<!--T:33-->
Drawing dimensions an toleranecs are still under development but you can get some basic functionality with a bit of work.
Drawing dimensions an toleranecs are still under development but you can get some basic functionality with a bit of work.


<!--T:34-->
First you need to get the gdtsvg python module from here (WARNING: This could be broken at any time!):
First you need to get the gdtsvg python module from here (WARNING: This could be broken at any time!):


<!--T:35-->
https://github.com/jcc242/FreeCAD
https://github.com/jcc242/FreeCAD


<!--T:36-->
To get a feature control frame, try out the following:
To get a feature control frame, try out the following:
</translate>
</translate>
Line 232: Line 262:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:37-->
Here is a good breakdown of the contents of a feature control frame: http://www.cadblog.net/adding-geometric-tolerances.htm
Here is a good breakdown of the contents of a feature control frame: http://www.cadblog.net/adding-geometric-tolerances.htm


<!--T:38-->
The parameters to pass to control frame are:
The parameters to pass to control frame are:
#X-coordinate in SVG-coordinate system (type string)
#X-coordinate in SVG-coordinate system (type string)
Line 248: Line 280:
#(optional) The third datum's material condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The third datum's material condition (tuple, svg string as first, width of symbol as second, height of symbol as third)


<!--T:39-->
The ControlFrame function returns a type containing (svg string, overall width of control frame, overall height of control frame)'''
The ControlFrame function returns a type containing (svg string, overall width of control frame, overall height of control frame)'''


<!--T:40-->
To get a dimension, try out the following:
To get a dimension, try out the following:
</translate>
</translate>
Line 258: Line 292:
</syntaxhighlight>
</syntaxhighlight>
<translate>
<translate>
<!--T:41-->
Inputs for linear dimension are:
Inputs for linear dimension are:
#point1, an (x,y) tuple with svg-coordinates, this is one of the points you would like to dimension between
#point1, an (x,y) tuple with svg-coordinates, this is one of the points you would like to dimension between
Line 267: Line 302:
#textstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the text looks
#textstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the text looks


<!--T:42-->
With those two, you can proceed as above for displaying them on the drawing page. This module is very buggy and can be broken at any given moment, bug reports are welcome on the github page for now, or contact jcc242 on the forums if you post a bug somewhere else.
With those two, you can proceed as above for displaying them on the drawing page. This module is very buggy and can be broken at any given moment, bug reports are welcome on the github page for now, or contact jcc242 on the forums if you post a bug somewhere else.


== Templates ==
== Templates == <!--T:43-->


<!--T:44-->
FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.
FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.


== Extending the Drawing Module ==
== Extending the Drawing Module == <!--T:45-->


<!--T:46-->
Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.
Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.


<!--T:47-->
{{docnav|Part Module|Raytracing Module}}
{{docnav|Part Module|Raytracing Module}}


<!--T:48-->
[[Category:User Documentation]]
[[Category:User Documentation]]
</translate>
</translate>

Revision as of 23:13, 29 November 2013

The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!

GUI Tools

Template:Drawing Tools


Note The Draft Module has its own Draft_Drawing too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like Draft dimensions.


In the picture you see the main concepts of the Drawing module. The document contains a shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The template is an SVG document which can hold your usual page frame, your logo or comply to your presentation standards.

In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes the page gets regenerated and the page display updated.

Scripting

At the moment the end user(GUI) workflow is very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.

Here a script that can easily fill the Macro_CartoucheFC leaf FreeCAD A3_Landscape.

Simple example

First of all you need the Part and the Drawing module:

 import FreeCAD, Part, Drawing

Create a small sample part

Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))

Direct projection. The G0 means hard edge, the G1 is tangent continuous.

 Shape = App.ActiveDocument.Shape.Shape
 [visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
 print "visible edges:", len(visibleG0.Edges)
 print "hidden edges:", len(hiddenG0.Edges)

Everything was projected on the Z-plane:

 print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
 print "Bnd Box project: X=",visibleG0.BoundBox.XLength," Y=",visibleG0.BoundBox.YLength," Z=",visibleG0.BoundBox.ZLength

Different projection vector

 [visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape,App.Vector(1,1,1))

Project to SVG

 resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
 print resultSVG

The parametric way

Create the body

 import FreeCAD
 import Part
 import Drawing

 # Create three boxes and a cylinder
 App.ActiveDocument.addObject("Part::Box","Box")
 App.ActiveDocument.Box.Length=100.00
 App.ActiveDocument.Box.Width=100.00
 App.ActiveDocument.Box.Height=100.00

 App.ActiveDocument.addObject("Part::Box","Box1")
 App.ActiveDocument.Box1.Length=90.00
 App.ActiveDocument.Box1.Width=40.00
 App.ActiveDocument.Box1.Height=100.00

 App.ActiveDocument.addObject("Part::Box","Box2")
 App.ActiveDocument.Box2.Length=20.00
 App.ActiveDocument.Box2.Width=85.00
 App.ActiveDocument.Box2.Height=100.00

 App.ActiveDocument.addObject("Part::Cylinder","Cylinder")
 App.ActiveDocument.Cylinder.Radius=80.00
 App.ActiveDocument.Cylinder.Height=100.00
 App.ActiveDocument.Cylinder.Angle=360.00
 # Fuse two boxes and the cylinder
 App.ActiveDocument.addObject("Part::Fuse","Fusion")
 App.ActiveDocument.Fusion.Base = App.ActiveDocument.Cylinder
 App.ActiveDocument.Fusion.Tool = App.ActiveDocument.Box1

 App.ActiveDocument.addObject("Part::Fuse","Fusion1")
 App.ActiveDocument.Fusion1.Base = App.ActiveDocument.Box2
 App.ActiveDocument.Fusion1.Tool = App.ActiveDocument.Fusion
 # Cut the fused shapes from the first box
 App.ActiveDocument.addObject("Part::Cut","Shape")
 App.ActiveDocument.Shape.Base = App.ActiveDocument.Box 
 App.ActiveDocument.Shape.Tool = App.ActiveDocument.Fusion1
 # Hide all the intermediate shapes 
 Gui.ActiveDocument.Box.Visibility=False
 Gui.ActiveDocument.Box1.Visibility=False
 Gui.ActiveDocument.Box2.Visibility=False
 Gui.ActiveDocument.Cylinder.Visibility=False
 Gui.ActiveDocument.Fusion.Visibility=False
 Gui.ActiveDocument.Fusion1.Visibility=False

Insert a Page object and assign a template

 App.ActiveDocument.addObject('Drawing::FeaturePage','Page')
 App.ActiveDocument.Page.Template = App.getResourceDir()+'Mod/Drawing/Templates/A3_Landscape.svg'

Create a view on the "Shape" object, define the position and scale and assign it to a Page

 App.ActiveDocument.addObject('Drawing::FeatureViewPart','View')
 App.ActiveDocument.View.Source = App.ActiveDocument.Shape
 App.ActiveDocument.View.Direction = (0.0,0.0,1.0)
 App.ActiveDocument.View.X = 10.0
 App.ActiveDocument.View.Y = 10.0
 App.ActiveDocument.Page.addObject(App.ActiveDocument.View)

Create a second view on the same object but this time the view will be rotated by 90 degrees.

 App.ActiveDocument.addObject('Drawing::FeatureViewPart','ViewRot')
 App.ActiveDocument.ViewRot.Source = App.ActiveDocument.Shape
 App.ActiveDocument.ViewRot.Direction = (0.0,0.0,1.0)
 App.ActiveDocument.ViewRot.X = 290.0
 App.ActiveDocument.ViewRot.Y = 30.0
 App.ActiveDocument.ViewRot.Scale = 1.0
 App.ActiveDocument.ViewRot.Rotation = 90.0
 App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewRot)

Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.

 App.ActiveDocument.addObject('Drawing::FeatureViewPart','ViewIso')
 App.ActiveDocument.ViewIso.Source = App.ActiveDocument.Shape
 App.ActiveDocument.ViewIso.Direction = (1.0,1.0,1.0)
 App.ActiveDocument.ViewIso.X = 335.0
 App.ActiveDocument.ViewIso.Y = 140.0
 App.ActiveDocument.ViewIso.ShowHiddenLines = True
 App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewIso)

Change something and update. The update process changes the view and the page.

 App.ActiveDocument.View.X = 30.0
 App.ActiveDocument.View.Y = 30.0
 App.ActiveDocument.View.Scale = 1.5
 App.ActiveDocument.recompute()

Accessing the bits and pieces

Get the SVG fragment of a single view

 ViewSVG = App.ActiveDocument.View.ViewResult
 print ViewSVG

Get the whole result page (it's a file in the document's temporary directory, only read permission)

 print "Resulting SVG document: ",App.ActiveDocument.Page.PageResult
 file = open(App.ActiveDocument.Page.PageResult,"r")
 print "Result page is ",len(file.readlines())," lines long"

Important: free the file!

 del file

Insert a view with your own content:

 App.ActiveDocument.addObject('Drawing::FeatureView','ViewSelf')
 App.ActiveDocument.ViewSelf.ViewResult = """<g id="ViewSelf"
   stroke="rgb(0, 0, 0)"
   stroke-width="0.35"
   stroke-linecap="butt"
   stroke-linejoin="miter"
   transform="translate(30,30)"
   fill="#00cc00"
   >

   <ellipse cx="40" cy="40" rx="30" ry="15"/>
   </g>"""
 App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewSelf)
 App.ActiveDocument.recompute()

 del ViewSVG

That leads to the following result:

General Dimensioning and Tolerancing

Drawing dimensions an toleranecs are still under development but you can get some basic functionality with a bit of work.

First you need to get the gdtsvg python module from here (WARNING: This could be broken at any time!):

https://github.com/jcc242/FreeCAD

To get a feature control frame, try out the following:

 import gdtsvg as g # Import the module, I like to give it an easy handle
 ourFrame = g.ControlFrame("0","0", g.Perpendicularity(), ".5", g.Diameter(), g.ModifyingSymbols("M"), "A",  
            g.ModifyingSymbols("F"), "B", g.ModifyingSymbols("L"), "C", g.ModifyingSymbols("I"))

Here is a good breakdown of the contents of a feature control frame: http://www.cadblog.net/adding-geometric-tolerances.htm

The parameters to pass to control frame are:

  1. X-coordinate in SVG-coordinate system (type string)
  2. Y-coordinate in SVG-coordinate system (type string)
  3. The desired geometric characteristic symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
  4. The tolerance (type string)
  5. (optional) The diameter symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
  6. (optional) The condition modifying material (tuple, svg string as first, width of symbol as second, height of symbol as third)
  7. (optional) The first datum (type string)
  8. (optional) The first datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
  9. (optional) The second datum (type string)
  10. (optional) The second datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
  11. (optional) The third datum (type string)
  12. (optional) The third datum's material condition (tuple, svg string as first, width of symbol as second, height of symbol as third)

The ControlFrame function returns a type containing (svg string, overall width of control frame, overall height of control frame)

To get a dimension, try out the following:

 import gdtsvg
 ourDimension = linearDimension(point1, point2, textpoint, dimensiontext, linestyle=getStyle("visible"), 
                arrowstyle=getStyle("filled"), textstyle=getStyle("text")

Inputs for linear dimension are:

  1. point1, an (x,y) tuple with svg-coordinates, this is one of the points you would like to dimension between
  2. point2, an (x,y) tuple with svg-coordinates, this is the second point you would like to dimension between
  3. textpoint, an (x,y) tuple of svg-coordinates, this is where the text of your dimension will be
  4. dimensiontext, a string containing the text you want the dimension to say
  5. linestyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling the how the lines look
  6. arrowstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the arrows look
  7. textstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the text looks

With those two, you can proceed as above for displaying them on the drawing page. This module is very buggy and can be broken at any given moment, bug reports are welcome on the github page for now, or contact jcc242 on the forums if you post a bug somewhere else.

Templates

FreeCAD comes bundled with a set of default templates, but you can find more on the Drawing templates page.

Extending the Drawing Module

Some notes on the programming side of the drawing module will be added to the Drawing Documentation page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.

Part Module
Raytracing Module